export declare const clamp: (num: number, lowerBound: number, upperBound: number) => number;
/**
 * Calculation the GridItem's Width and height.
 * @param   {Number}    gridUnits
 * @param   {Number}    colOrRowSize
 * @param   {Number}    marginPx
 * @return  {Number}    The result of the calculation. If gridUnits is not infinite, it returns the gridUnits.
 *                      Otherwise, the result is being calculated.
 */
export declare const calcGridItemWH: (gridUnits: number, colOrRowSize: number, marginPx: number) => number;
/**
 * Calculating the Column width.
 * @param   {Number}    containerWidth      The width of the GridLayout container
 * @param   {Number}    marginLeftRight     Left snd Right margin value.
 * @param   {Number}    cols                Number of columns defined in the layout.
 * @return  {Number}                        The new column width.
 */
export declare const calcColWidth: (containerWidth: number, marginLeftRight: number, cols: number) => number;
