import { ILayoutItem, TLayout } from '@/components';
/**
 * Given two layout items, check if they collide.
 *
 * @return {Boolean}   True if colliding.
 */
export declare function collides(l1: ILayoutItem, l2: ILayoutItem): boolean;
/**
 * Returns all the items which collides in the layout
 * It doesn't appear to matter which order we approach this from, although
 * perhaps that is the wrong thing to do.
 *
 * @param  {TLayout}     layout     The entire grid layout.
 * @param  {ILayoutItem} layoutItem Layout item.
 * @return {ILayoutItem|undefined}  A colliding layout item, or undefined.
 * @throws {Error}                  Empty layout.
 */
export declare function getAllCollisions(layout: TLayout, layoutItem: ILayoutItem): ILayoutItem[];
/**
 * Returns the first item this layout collides with.
 * It doesn't appear to matter which order we approach this from, although
 * perhaps that is the wrong thing to do.
 *
 * @param  {TLayout}     layout     The entire grid layout.
 * @param  {ILayoutItem} layoutItem Layout item.
 * @return {ILayoutItem|undefined}  A colliding layout item, or undefined.
 * @throws {Error}                  Empty layout.
 */
export declare function getFirstCollision(layout: TLayout, layoutItem: ILayoutItem): ILayoutItem | undefined;
