/**
 * Adding a event listener to the window object.
 * @param {String}    event     Name of the event to listen for.
 * @param {Function}  callback  Callback function.
 * @see   https://developer.mozilla.org/en-US/docs/Web/API/EventTarget/addEventListener
 */
export declare const addWindowEventListener: (event: string, callback: () => any) => boolean;
/**
 * Removing a event listener from the window object.
 * @param {String}    event     Name of the event to remove.
 * @param {Function}  callback  Callback function.
 * @see   https://developer.mozilla.org/en-US/docs/Web/API/EventTarget/removeEventListener
 */
export declare const removeWindowEventListener: (event: string, callback: () => any) => void;
