import { ICalcXy } from '@/core/griditem/interfaces/grid-item.interfaces';
/**
 * Translate x and y coordinates from pixels to grid units.
 * @param   {Number}    top             Top position (relative to parent) in pixels.
 * @param   {Number}    left            Left position (relative to parent) in pixels.
 * @param   {[]}        margin          Left Right margin.
 * @param   {Number}    rowHeight       Height of each row in the layout.
 * @param   {Number}    cols            Number of GridItem columns specified in the GridLayout (colNum property in the GridLayout component).
 * @param   {Number}    innerH          GridItem height in GridLayout units.
 * @param   {Number}    innerW          GridItem width in GridLayout units.
 * @param   {Number}    maxRows         Number of rows (maxRows property in GridLayout) in the GridLayout.
 * @param   {Number}    containerWidth  Width of the GridLayout container.
 * @return  {ICalcXy}                   x and y in grid units.
 */
export declare const calcXY: (top: number, left: number, margin: [x: number, y: number], rowHeight: number, cols: number, innerH: number, innerW: number, maxRows: number, containerWidth: number) => ICalcXy;
