import { TLayout } from '@/components/Grid/layout-definition';
/**
 * Given a layout, make sure all elements fit within its bounds.
 *
 * @param     {TLayout}  layout             Layout array.
 * @param     {Number}  bounds              Number of columns.
 * @param     {Boolean} distributeEvenly    Enforces that a grid item is moved all the way to left/right when there is available space for it
 * @returns   {TLayout}                     The new adjusted layout.
 */
export declare function correctBounds(layout: TLayout, bounds: {
    cols: number;
}, distributeEvenly: boolean): TLayout;
